using System;
using System.Collections;
using System.Text;

using Cosmos.UserFrame;
using Cosmos.ServiceProvider;
using Cosmos.Common;
using Cosmos.CommonManager;
using System.Data;

/*-----------------------------------------------------------------------------------------------*/
// 설      명 : 해피포인트 적립
// 작  성  자 : 
// 변경  이력 : 
/*-----------------------------------------------------------------------------------------------*/
namespace Cosmos.Service
{
    class PointHappyPoint : PaymentBase, IPaymentUs, IPaymentExpUs
    {
        /// <summary>
        /// 현재 등록중인 기타 정보
        /// </summary>
        protected Column.TR_ETC.DATA m_cEtcItem = null;

        public PointHappyPoint()
        {
        }

        #region SearchPayment 결제 조회
        /// <summary>
        /// 결제 조회(해피포인트조회)
        /// </summary>
        /// <param name="aParam"></param>
        /// <param name="aRet"></param>
        /// <returns></returns>
        public string SearchPayment(string[] aParam, ref string[] aRet)
        {
            string sRet = UserCom.RST_ERR;

            string sInPutType = "", sInPutData = "", sInEncData = "", sServiceCode = "", sAppCardNo = "";
            try
            {
                sInPutType = aParam[0];                             // 입력구분
                sInPutData = aParam[1];                             // 입력데이터(마스킹)
                sInEncData = aParam[2];                             // 카드데이터(암호화)
                m_bErrMsgShow = aParam[3] == "0" ? false : true;    // 메시지 출력여부(0:미출력, 1;출력)
                if (aParam.Length > 4) sServiceCode = aParam[4];    // 서비스코드
                if (aParam.Length > 5) sAppCardNo = aParam[5];      // 승인카드번호
                m_cEtcItem = new Column.TR_ETC.DATA();              // 결과 저장 변수 생성
                m_cEtcItem.ETC_WAY_CD = ItemConst.TR_ITEM_ID.ETC_INFO_ITEM;
                m_cEtcItem.ETC_DTL_CD_01 = ItemConst.TR_ITEM_ID.ETC_INFO.SAVEPOINT; //  2019-04-17 - 1997fx11 : 해피포인트 적립여부

                sRet = ExecutePointHappyPointIrt(PosConst.CANCEL_DIV.NORMAL, PosConst.POS_VAN_MASTER.TRADE_ID.VAN_POT_QRY_A, "HPY", sInPutType, sInPutData, sInEncData, 0, 0, "", "", "", "");
                if (sRet != UserCom.RST_OK) return sRet;

                if (m_cEtcItem.HP_ADD_INFO_SCH.Trim() != "")
                {
                    int nNowPos = 0;
                    string[] aIrtRsp = new string[Column.POINT_ADD_INFO_SEARCH.LEN.Length];
                    ItemColumn.ParseMessage(Column.POINT_ADD_INFO_SEARCH.LEN, Column.POINT_ADD_INFO_SEARCH.TYPE, Encoding.Default.GetBytes(m_cEtcItem.HP_ADD_INFO_SCH), ref nNowPos, ref aIrtRsp);

                    // 포인트 적립가능여부
                    if (aIrtRsp[Column.POINT_ADD_INFO_SEARCH.SEQ.pointHPADDYN] != "Y")
                    {
                        if( m_bErrMsgShow == true) WinManager.ConfirmMessage(MessageManager.GetErrorMessage(POS_MESSAGE.ERROR.MSG_0070));
                        return UserCom.RST_ERR;
                    }
                    // 앱고객 여부(N:일반, Y:앱고객)
                    m_cEtcItem.OCCUR_ENTRY_12 = aIrtRsp[Column.POINT_ADD_INFO_SEARCH.SEQ.pointHPAPPYN];
                    // 고객명 설정
                    string sCustInfo = aIrtRsp[Column.POINT_ADD_INFO_SEARCH.SEQ.pointMEMINFO];
                    if (sCustInfo != "" && CmUtil.IntParse(sCustInfo.Substring(0, 1)) > 0)
                    {
                        m_cEtcItem.HP_CUST_NAME = CmUtil.MidH(sCustInfo, 17, 20).Trim();    // 고객명
                        //#20180821 해피포인트 고객이름 마스킹 start
                        if (m_cEtcItem.HP_CUST_NAME != "") { m_cEtcItem.HP_CUST_NAME = m_cDataCommon.NameMasking(m_cEtcItem.HP_CUST_NAME); }
                        //#20180821 해피포인트 고객이름 마스킹 end

                        m_cEtcItem.OCCUR_ENTRY_10 = CmUtil.MidH(sCustInfo, 45, 35).Trim();  // 회원번호
                    }
                    m_cEtcItem.ETC_DTL_CD_04 = aIrtRsp[Column.POINT_ADD_INFO_SEARCH.SEQ.pointCARDGBCD].Trim();
                    // 소멸예정포인트
                    m_cEtcItem.HP_EXT_POINT = CmUtil.LongParse( aIrtRsp[Column.POINT_ADD_INFO_SEARCH.SEQ.pointDELHPPOINT]);
                    // 비밀번호 사용여부
                    m_cEtcItem.HP_PASSWORD_YN = aIrtRsp[Column.POINT_ADD_INFO_SEARCH.SEQ.pointHPUSEPWYN];
                    // 회원등급코드
                    m_cEtcItem.OCCUR_ENTRY_15 = aIrtRsp[Column.POINT_ADD_INFO_SEARCH.SEQ.pointMEMGB].Trim();

                    //#20171017 전자영수증 발행 start, phj
                    m_cEtcItem.OCCUR_ENTRY_23 = CmUtil.MidH(m_cEtcItem.HP_ADD_INFO_SCH, 144, 1).Trim();
                    //#20171017 전자영수증 발행 end, phj

                    //#20180413 웰컴카드 신규기능 추가 start,phj

                    int t_nNowPos = 0;
                    string[] t_aIrtRsp = null;
                    t_aIrtRsp = new string[Column.POINT_ADD_INFO_SEARCH.LEN.Length];
                    byte[] t_bytes = Encoding.Default.GetBytes(m_cEtcItem.HP_ADD_INFO_SCH);
                    ItemColumn.ParseMessage(Column.POINT_ADD_INFO_SEARCH.LEN, Column.POINT_ADD_INFO_SEARCH.TYPE, t_bytes, ref t_nNowPos, ref t_aIrtRsp);

                    string HP_WelcomeCard = "";
                    HP_WelcomeCard = t_aIrtRsp[Column.POINT_ADD_INFO_SEARCH.SEQ.pointRESERVED].Trim();
                    HP_WelcomeCard = CmUtil.MidH(HP_WelcomeCard, 0, 20).Trim();
                    m_cEtcItem.OCCUR_ENTRY_19 = HP_WelcomeCard; // 웰컴카드번호

                    //#20180413 웰컴카드 신규기능 추가 end,phj 
                }
                m_cEtcItem.OCCUR_ENTRY_14 = sAppCardNo;     // 승인카드번호

                //m_cEtcItem.AMT_ENTRY_08 = m_cDataService.GetPluTagetAmount(PosKey.MENU_KEY.HAPPY_POINT); // 적립 대상 금액
                //m_cEtcItem.ETC_AMT = m_cDataCommon.ExecTermCoopCmpPayDc(m_cEtcItem.ETC_WAY_CD, m_cEtcItem.ETC_DTL_CD_01, "", m_cEtcItem.AMT_ENTRY_08); // 제휴사 결제 할인 금액 계산
            }
            catch (Exception ex)
            {
                if (m_bErrMsgShow)
                {
                    WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                       System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
                }
            }
            finally
            {
                //여전법 대응!
                //////////////////////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref sInPutData);
                CmUtil.ZeroFillClear(ref sInEncData);
                CmUtil.ZeroFillClear(ref aParam);
                //////////////////////////////////////////////////////////////////////////////////
                m_bErrMsgShow = true;
            }
            return sRet;
        }
        #endregion

        #region GetPayment 결제 정보 획득
        /// <summary>
        /// 결제 정보 획득
        /// </summary>
        /// <param name="aParam"></param>
        /// <returns></returns>
        public object GetPayment(string[] aParam)
        {
            return m_cEtcItem;
        }
        #endregion

        #region SetPayment 결제 등록
        /// <summary>
        /// 결제 등록(해피포인트 카드 등록)
        /// </summary>
        /// <param name="aParam"></param>
        /// <returns></returns>
        public string SetPayment(string[] aParam)
        {
            string sRet = UserCom.RST_ERR;
            string sInPutType = "", sInPutData = "", sInEncData = "", sServiceCode = "", sAppCardNo = "";

            try
            {
                sInPutType = aParam[0];                             // 입력구분
                sInPutData = aParam[1];                             // 입력데이터(마스킹)
                sInEncData = aParam[2];                             // 카드데이터(암호화)
                m_bErrMsgShow = aParam[3] == "0" ? false : true;    // 메시지 출력여부(0:미출력, 1;출력)
                if (aParam.Length > 4) sServiceCode = aParam[4];    // 서비스코드
                if (aParam.Length > 5) sAppCardNo = aParam[5];      // 승인카드번호

                // 해피포인트 카드 기등록 여부 체크
                ArrayList alEtcItem = (ArrayList)StateObject.GetItemObject(Column.TR_ETC.ITEM);     // 기타 내역 받아 오기
                foreach (Column.TR_ETC.DATA cEtcItem in alEtcItem)
                {
                    if (cEtcItem.CANCEL_DIV == PosConst.CANCEL_DIV.CANCEL) continue;

                    if (cEtcItem.ETC_WAY_CD == ItemConst.TR_ITEM_ID.ETC_INFO_ITEM && cEtcItem.ETC_DTL_CD_01 == ItemConst.TR_ITEM_ID.ETC_INFO.SAVEPOINT) return UserCom.RST_OK;
                }

                // 결제할인 마스터의 결제할인 중복 가능 여부 체크
                if (m_cDataCommon.PayDcDuplicationCheck(ItemConst.TR_ITEM_ID.ETC_INFO_ITEM, ItemConst.TR_ITEM_ID.ETC_INFO.SAVEPOINT, false) == false) return sRet;

                // 해피포인트 아이템 설정
                m_cEtcItem.SEQ = alEtcItem.Count + 1;
                alEtcItem.Add(m_cEtcItem);

                if (m_cTrnStatus.Sale.RemainPayAmt > 0)
                {
                    //#15583 캠페인 기능 개선 요청 start
                    //해당 조건 제외
                    /*
                    // 모바일쿠폰 등록 후 해피포인트 등록 처리(2017.08.28) -- START
                    // 모바일쿠폰이 등록 되어 있으면 해피포인트 할인 캠페인 처리 안하도록 처리
                    ArrayList alPayItem = (ArrayList)StateObject.GetItemObject(Column.TR_PAYMENT.ITEM);
                    foreach (Column.TR_PAYMENT.DATA cPayItem in alPayItem)
                    {
                        if (cPayItem.CANCEL_DIV != PosConst.CANCEL_DIV.NORMAL) continue;
                        
                        if (cPayItem.PAY_WAY_CD == ItemConst.TR_ITEM_ID.MOBILECON_ITEM)
                        {
                            m_cDataService.UpdatePluAmount();       // 상품 합계금액 계산(거래해더)
                            m_cDataService.UpdatePayAmount();       // 결제 금액 재 계산 처리

                            return UserCom.RST_OK;
                        }
                    }
                    // 모바일쿠폰 등록 후 해피포인트 등록 처리(2017.08.28) -- END
                    */
                    //#15583 캠페인 기능 개선 요청 end

                    // 캠페인(해피포인트 할인) 처리(키값(취소시사용), 카드번호, 고객구분(앱여부), 고객ID, 고객등급)
                    m_cEtcItem.AMT_ENTRY_02 = m_cCampaingMain.ExecuteCampaignPluHappyPoint(PosConst.CAMPAIGN_PAY_KEY.HP_DIS, false, PosConst.SALE_PLU_INPUT_TYPE.FREEGIFT_HP,
                        sInPutData, m_cEtcItem.OCCUR_ENTRY_12, m_cEtcItem.OCCUR_ENTRY_10, m_cEtcItem.OCCUR_ENTRY_15);  // 해피포인트 캠페인 계산
                    
                    //#20170809 할인 캠페인 금액 체크 수정 start
                    //할인 캠페인 적용 후 받을 금액이 할인금액보다 작으면 캠페인 적용 안되는 부분 수정.
                    //(할인 적용 후 받을금액이 이미 계산된 상태에서 비교해서 50%이상 할인을 하게 되면 적용이 안되는 로직임.
                    //기존
                    //if (m_cEtcItem.AMT_ENTRY_02 > m_cTrnStatus.Sale.RemainPayAmt)
                    //변경
                    if (m_cTrnStatus.Sale.RemainPayAmt <= 0)
                    //#20170809 할인 캠페인 금액 체크 수정 end
                    {
                        if (m_bErrMsgShow == true) WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0391);

                        m_cEtcItem.AMT_ENTRY_02 = 0;
                        // 캠페인(해피포인트 할인) 취소 처리
                        m_cCampaingMain.ExecuteCampaignPluHappyPoint("", false, "", "", "", "");  // 상품 캠페인 계산
                    }
                }

                //m_cEtcItem.AMT_ENTRY_08 = m_cDataService.GetPluTagetAmount(PosKey.MENU_KEY.HAPPY_POINT);                                    // 적립 대상 금액
                //m_cEtcItem.ETC_AMT = m_cDataCommon.ExecTermCoopCmpPayDc(m_cEtcItem.ETC_WAY_CD, m_cEtcItem.ETC_DTL_CD_01, "", m_cEtcItem.AMT_ENTRY_08);    // 제휴사 결제 할인 금액 계산(적립예정점수)

                m_cDataService.UpdatePluAmount();       // 상품 합계금액 계산(거래해더)
                m_cDataService.UpdatePayAmount();       // 결제 금액 재 계산 처리

                sRet = UserCom.RST_OK;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                   System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            finally
            {
                //여전법 대응!
                //////////////////////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref sInPutData);
                CmUtil.ZeroFillClear(ref sInEncData);
                CmUtil.ZeroFillClear(ref aParam);
                //////////////////////////////////////////////////////////////////////////////////
                m_bErrMsgShow = true;
            }
            return sRet;
        }
        #endregion

        #region CancelPayment 결제 취소
        /// <summary>
        /// 결제 취소(해피포인트 카드 등록취소)
        /// </summary>
        /// <param name="aParam"></param>
        /// <returns></returns>
        public string CancelPayment(string[] aParam)
        {
            string sRet = UserCom.RST_ERR;

            try
            {
                if (m_cTrnStatus.Head.TradeDiv != ItemConst.TRAN_DIV.NORMAL) return sRet;

                int nPayRow = CmUtil.IntParse(aParam[0]); // 취소할 행번호

                ArrayList alEtcItem = (ArrayList)StateObject.GetItemObject(Column.TR_ETC.ITEM);     // 기타 내역 받아 오기
                m_cEtcItem = (Column.TR_ETC.DATA)alEtcItem[nPayRow];

                m_cEtcItem.CANCEL_DIV = PosConst.CANCEL_DIV.CANCEL;

                m_cTrnStatus.Sale.HappyBuzzMemNo = "";

                // 캠페인(해피포인트 할인) 취소 처리
                m_cCampaingMain.ExecuteCampaignPluHappyPoint("", false, "", "", "", "");  // 상품 캠페인 계산
                
                m_cDataService.UpdatePluAmount();       // 상품 합계금액 계산(거래해더)
                m_cDataService.UpdatePayAmount();       // 결제 금액 재 계산 처리

                sRet = UserCom.RST_OK;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                   System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            return sRet;
        }
        #endregion

        #region CompletePayment 결제 확정
        /// <summary>
        /// 결제 확정(해피포인트 카드 적립)
        /// </summary>
        /// <param name="aParam"></param>
        /// <returns></returns>
        public string CompletePayment(string[] aParam)
        {
            string sRet = UserCom.RST_ERR;

            string sInPutType = "", sInPutData = "", sInEncData = "";

            try
            {
                m_cEtcItem = null;

                ArrayList alEtcItem = (ArrayList)StateObject.GetItemObject(Column.TR_ETC.ITEM);     // 기타 내역 받아 오기
                foreach (Column.TR_ETC.DATA cEtcItem in alEtcItem)
                {
                    if (cEtcItem.CANCEL_DIV == ItemConst.PAY_CANCEL_DIV.CANCEL) continue;

                    if (cEtcItem.ETC_WAY_CD == ItemConst.TR_ITEM_ID.ETC_INFO_ITEM && cEtcItem.ETC_DTL_CD_01 == ItemConst.TR_ITEM_ID.ETC_INFO.SAVEPOINT)
                    {
                        m_cEtcItem = cEtcItem;
                        break;
                    }
                }


                if (aParam.Length > 0 && aParam[0] == PosConst.POS_CAT_MASTER.TRAN_TYPE)    //단말기승인
                {

                    bool bNewAddFlag = false;

                    if (m_cEtcItem == null)
                    {
                        bNewAddFlag = true;
                        m_cEtcItem = new Column.TR_ETC.DATA();
                    }
                    
                    m_cEtcItem.ETC_WAY_CD = ItemConst.TR_ITEM_ID.ETC_INFO_ITEM;
                    m_cEtcItem.ETC_DTL_CD_01 = ItemConst.TR_ITEM_ID.ETC_INFO.SAVEPOINT;


                    //적립 대상 금액 셋팅
                    if (CmUtil.DoubleParse(aParam[3]) == 0)
                    {
                        aParam[3] = m_cTrnStatus.Head.AftSavePoint.ToString();
                    }

                    if (m_cTrnStatus.Head.AftSaveAddInfo != "")
                    {
                        aParam[11] = m_cTrnStatus.Head.AftSaveAddInfo.Substring(26);
                    }
                    m_cEtcItem.AMT_ENTRY_09 = m_cTrnStatus.Head.AftSavePoint;       // 기본적립대상금액

                    sRet = CatExecuteIrt(aParam[1], aParam);
                    if (sRet != UserCom.RST_OK) return sRet;

                    if (bNewAddFlag == true)
                    {
                        m_cEtcItem.SEQ = alEtcItem.Count + 1;
                        alEtcItem.Add(m_cEtcItem);
                    }
                }
                else
                {
                    if (m_cEtcItem == null) return sRet;

                    sInPutType = m_cEtcItem.OCCUR_ENTRY_05;          // 입력구분
                    sInPutData = m_cEtcItem.OCCUR_ENTRY_01;          // 입력데이터(마스킹)
                    sInEncData = m_cEtcItem.CanFiller1;              // 카드데이터(암호화)

                    double nNetSaleAmt = m_cTrnStatus.Sale.NetSaleAmt;      // 영수금액
                    double nBasicSaveAmt = m_cTrnStatus.Head.AftSavePoint;  // 적립대상금액
                    if (aParam.Length > 0 && CmUtil.DoubleParse(aParam[0]) > 0) nBasicSaveAmt = CmUtil.DoubleParse(aParam[0]);

                    // 추가적립 정보[캠페인코드(10)+대상상품금액(15)+추가적립여부(1)+추가적립상세코드(2)+본사부담금(7)+매장부담금(7)]
                    string sHP_ADD_ACCUME = "";
                    if (m_cTrnStatus.Head.AftSaveAddInfo != "")
                    {
                        string sCPI_CD = m_cTrnStatus.Head.AftSaveAddInfo.Substring(0, 10).Trim();
                        double nAddSaveAmt = CmUtil.DoubleParse(m_cTrnStatus.Head.AftSaveAddInfo.Substring(10, 15).Trim());
                        sHP_ADD_ACCUME = m_cTrnStatus.Head.AftSaveAddInfo.Substring(25);
                        double nAddSavePnt = CmUtil.DoubleParse(sHP_ADD_ACCUME.Substring(3, 7));
                        if (sHP_ADD_ACCUME.StartsWith("N") == true)
                        {
                            sHP_ADD_ACCUME = sHP_ADD_ACCUME.Substring(0, 3) + string.Format("{0:D7}{1:D7}", 0, 0);
                        }
                        m_cEtcItem.ETC_DTL_CD_02 = sCPI_CD;                         // 캠페인코드
                        m_cEtcItem.AMT_ENTRY_10 = nAddSaveAmt;                      // 추가적립대상금액
                    }
                    m_cEtcItem.AMT_ENTRY_09 = m_cTrnStatus.Head.AftSavePoint;       // 기본적립대상금액

                    string sHpStampPlu = m_cCampaingMain.GetCampaignHappyStampInfo();   // 스탬프캠페인 상품 획득
                    while (true)
                    {
                        // 해피포인트 적립 승인 처리
                        sRet = ExecutePointHappyPointIrt(PosConst.CANCEL_DIV.NORMAL, PosConst.POS_VAN_MASTER.TRADE_ID.VAN_POT_ACC_A, "HPY", sInPutType, sInPutData, sInEncData
                            , nNetSaleAmt, nBasicSaveAmt, sHP_ADD_ACCUME, sHpStampPlu, "", "");
                        if (sRet != UserCom.RST_OK)
                        {
                            if (WinManager.QuestionMessage(MessageManager.GetErrorMessage(POS_MESSAGE.ERROR.MSG_0115)) == true) continue;

                            return sRet;
                        }
                        break;
                    }

                    // 추가적립 정보 및 고객명 설정
                    string sStampCntInfo = "";
                    m_cEtcItem.OCCUR_ENTRY_11 = "0";        // 추가적립여부
                    if (m_cEtcItem.HP_ADD_INFO_SAVE.Trim() != "")
                    {
                        int nNowPos = 0;
                        string[] aIrtRsp = new string[Column.POINT_ADD_INFO_SAVE.LEN.Length];
                        ItemColumn.ParseMessage(Column.POINT_ADD_INFO_SAVE.LEN, Column.POINT_ADD_INFO_SAVE.TYPE, Encoding.Default.GetBytes(m_cEtcItem.HP_ADD_INFO_SAVE), ref nNowPos, ref aIrtRsp);

                        m_cEtcItem.AMT_ENTRY_07 = CmUtil.DoubleParse(aIrtRsp[Column.POINT_ADD_INFO_SAVE.SEQ.AddSavePnt]);   // 추가적립포인트
                        m_cEtcItem.OCCUR_ENTRY_11 = (aIrtRsp[Column.POINT_ADD_INFO_SAVE.SEQ.AddSaveYN] == "Y") ? "1" : "0"; // 추가적립여부
                        m_cEtcItem.HP_CUST_NAME = aIrtRsp[Column.POINT_ADD_INFO_SAVE.SEQ.CustName].Trim();                  // 고객명 설정
                        //#20180821 해피포인트 고객이름 마스킹 start
                        if (m_cEtcItem.HP_CUST_NAME != "") { m_cEtcItem.HP_CUST_NAME = m_cDataCommon.NameMasking(m_cEtcItem.HP_CUST_NAME); }
                        //#20180821 해피포인트 고객이름 마스킹 end

                        sStampCntInfo = aIrtRsp[Column.POINT_ADD_INFO_SAVE.SEQ.StampInfo].Trim();                           // 스템프정보(구매,잔여,누적)
                    }

                    // 스템프 캠페인 정보 설정
                    if (m_cEtcItem.HP_CAMPAIGN_INFO.Length >= 16)
                    {
                        m_cCampaingMain.SetCampaignHappyStampInfo(m_cEtcItem.HP_CAMPAIGN_INFO, sStampCntInfo, m_cEtcItem.OCCUR_ENTRY_10);
                    }
                }
                // 적립완료 => 추후 적립 가능정보 초기화
                m_cTrnStatus.Head.AftSavePoint = 0;
                m_cTrnStatus.Head.AftSaveAddInfo = "";

                sRet = UserCom.RST_OK;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                   System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            finally
            {
                //여전법 대응!
                //////////////////////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref sInPutData);
                CmUtil.ZeroFillClear(ref sInEncData);
                CmUtil.ZeroFillClear(ref aParam);
                //////////////////////////////////////////////////////////////////////////////////
            }
            return sRet;
        }
        #endregion

        #region RefundPayment 결제 반품
        /// <summary>
        /// 결제 반품(해피포인트 카드 적립취소)
        /// </summary>
        /// <param name="aParam"></param>
        /// <returns></returns>
        public string RefundPayment(string[] aParam)
        {
            string sRet = UserCom.RST_ERR;
            string sInPutType = "", sInMskData = "", sInEncData = "";

            try
            {
                //#20171020 log 추가 
                UserLog.WriteLogFile(UserCom.LOG_IOS, System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                    System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", " HPPoint - 거래구분 : " + m_cTrnStatus.Head.TradeDiv);

                int nPayRow = CmUtil.IntParse(aParam[0]);       // 취소할 행번호

                ArrayList alEtcItem = (ArrayList)StateObject.GetItemObject(Column.TR_ETC.ITEM);     // 기타 내역 받아 오기
                m_cEtcItem = (Column.TR_ETC.DATA)alEtcItem[nPayRow];


                if (m_cEtcItem.OCCUR_ENTRY_08.ToString() == ItemConst.PAY_APP_DIV.CAT_TERMINAL)
                {

                    string[] m_aParam = new string[15];

                    //InParam
                    // 0.전문구분,1.거래유형, 2.할부개월, 3.승인금액 , 4.봉사료, 5.세금, 6.원승인번호, 7.원거래일자, 8.포인트거래구분, 9.상품코드,
                    //10.전표인쇄여부,11.추가항목,12.제휴할인코드,13.제휴할인금액,14.예비1

                    string sAppId = PosConst.POS_CAT_MASTER.TRADE_ID.CAT_HAPPY_CANCEL;

                    m_aParam[0] = PosConst.POS_CAT_MASTER.TRAN_TYPE;
                    m_aParam[1] = sAppId;
                    m_aParam[2] = m_cEtcItem.OCCUR_ENTRY_14;
                    m_aParam[3] = m_cEtcItem.AMT_ENTRY_08.ToString();
                    m_aParam[4] = "0"; //봉사료
                    m_aParam[5] = "0"; //세금
                    m_aParam[6] = m_cEtcItem.OCCUR_ENTRY_02;
                    m_aParam[7] = m_cEtcItem.OCCUR_ENTRY_03;
                    m_aParam[8] = "";
                    m_aParam[9] = "";
                    m_aParam[10] = "";
                    m_aParam[11] = "";
                    m_aParam[12] = "";
                    m_aParam[13] = "";
                    m_aParam[14] = "";

                    sRet = CatExecuteIrt(m_aParam[1], m_aParam);
                    if (sRet != UserCom.RST_OK) return sRet;
                }
                else
                {


                    sInPutType = m_cEtcItem.OCCUR_ENTRY_05;          // 입력구분
                    sInMskData = m_cEtcItem.OCCUR_ENTRY_01;          // 입력데이터(마스킹)
                    sInEncData = m_cEtcItem.CanFiller1;              // 카드데이터(암호화)

                    if (m_cEtcItem.OCCUR_ENTRY_08.ToString() != ItemConst.PAY_APP_DIV.NORMAL)
                    {
                        //WinManager.ConfirmMessage(MessageManager.GetErrorMessage(POS_MESSAGE.ERROR.MSG_0240));
                        m_cEtcItem.OCCUR_ENTRY_06 = m_cEtcItem.OCCUR_ENTRY_02;              // 원승인번호
                        m_cEtcItem.OCCUR_ENTRY_07 = m_cEtcItem.OCCUR_ENTRY_03;              // 원승인일자
                    }
                    else
                    {
                        double nNetSaleAmt = m_cTrnStatus.Sale.NetSaleAmt;      // 영수금액
                        double nBasicSaveAmt = m_cEtcItem.AMT_ENTRY_08;         // 적립대상금액
                        string sApprDate = m_cEtcItem.OCCUR_ENTRY_03;           // 승인일자
                        string sApprNo = m_cEtcItem.OCCUR_ENTRY_02;             // 승인번호

                        //#해피앱 추후적립 start, sskim
                        //기존
                        //sRet = ExecutePointHappyPointIrt(PosConst.CANCEL_DIV.CANCEL, PosConst.POS_VAN_MASTER.TRADE_ID.VAN_POT_ACC_C, "HPY", sInPutType, sInMskData, sInEncData, nNetSaleAmt, nBasicSaveAmt, "", "", sApprDate, sApprNo);
                        //변경
                        if (m_cEtcItem.OCCUR_ENTRY_22 == "1")
                        {
                            sRet = ExecutePointHappyPointIrt(PosConst.CANCEL_DIV.CANCEL, PosConst.POS_VAN_MASTER.TRADE_ID.VAN_POT_QRY_A, "HPY", sInPutType, sInMskData, sInEncData, nNetSaleAmt, nBasicSaveAmt, "", "", sApprDate, sApprNo);
                        }
                        else
                        {
                            sRet = ExecutePointHappyPointIrt(PosConst.CANCEL_DIV.CANCEL, PosConst.POS_VAN_MASTER.TRADE_ID.VAN_POT_ACC_C, "HPY", sInPutType, sInMskData, sInEncData, nNetSaleAmt, nBasicSaveAmt, "", "", sApprDate, sApprNo);
                        }
                        //#해피앱 추후적립 end, sskim

                        if (sRet != UserCom.RST_OK) return sRet;

                        if (m_cEtcItem.HP_ADD_INFO_SAVE.Trim() != "")
                        {
                            int nNowPos = 0;
                            string[] aIrtRsp = new string[Column.POINT_ADD_INFO_SAVE.LEN.Length];
                            ItemColumn.ParseMessage(Column.POINT_ADD_INFO_SAVE.LEN, Column.POINT_ADD_INFO_SAVE.TYPE, Encoding.Default.GetBytes(m_cEtcItem.HP_ADD_INFO_SAVE), ref nNowPos, ref aIrtRsp);

                            m_cEtcItem.HP_CUST_NAME = aIrtRsp[Column.POINT_ADD_INFO_SAVE.SEQ.CustName].Trim();                  // 고객명 설정
                            //#20180821 해피포인트 고객이름 마스킹 start
                            if (m_cEtcItem.HP_CUST_NAME != "") { m_cEtcItem.HP_CUST_NAME = m_cDataCommon.NameMasking(m_cEtcItem.HP_CUST_NAME); } 
                            //#20180821 해피포인트 고객이름 마스킹 end
                        }
                    }
                }

                // 여전법 대응 ///////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref m_cEtcItem.CanFiller1);
                //////////////////////////////////////////////////////////////////////////////////
                sRet = UserCom.RST_OK;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                   System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            finally
            {
                //여전법 대응!
                //////////////////////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref sInMskData);
                CmUtil.ZeroFillClear(ref sInEncData);
                CmUtil.ZeroFillClear(ref aParam);
                //////////////////////////////////////////////////////////////////////////////////
            }
            return sRet;
        }
        #endregion

        #region SetMenualPayment
        public string SetMenualPayment(string[] aParam)
        {
            throw new NotImplementedException();
        }
        #endregion

        #region SetSmilePayment 스마일페이 해피포인트 등록.

        /// <summary>
        /// 해피포인트 제휴카드 등록
        /// </summary>
        /// <param name="aParam"></param>
        /// <returns></returns>
        public string SetSmilePayment(string[] aParam)
        {
            string sRet = UserCom.RST_ERR;
            string sInPutType = "", sInPutData = "" ,sInEncData = "", sInOrgData = "";

            try
            {
                // 해피포인트 제휴카드 등록 시 해피포인트 업무 옵션 체크(2017.09.08)
                ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                // 해피 포인트 적립 처리
                ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                if (PosMstManager.GetPosOption(POS_OPTION.OPT316) == "0") return sRet;           // 해피포인트 업무 사용 여부(0:사용안함, 1:사용함(한국), 2:사용함(중국))
                //if (PosMstManager.GetPosOption(POS_OPTION.OPT030) == "0") return sRet;           // HP 자동적립 처리(0:사용안함, 1:사용함)

                sInPutType = aParam[0];                         // 입력구분
                sInPutData = aParam[1];                         // 마스킹데이터
                sInEncData = aParam[2];                         // 암호화 데이터
                sInOrgData = aParam[5];                         // 입력카드데이터


                // 결제할인 마스터의 결제할인 중복 가능 여부 체크
                if (m_cDataCommon.PayDcDuplicationCheck(ItemConst.TR_ITEM_ID.ETC_INFO_ITEM, ItemConst.TR_ITEM_ID.ETC_INFO.SAVEPOINT, false) == false) return sRet;

                // 해피포인트 카드 기등록 여부 체크
                ArrayList alEtcItem = (ArrayList)StateObject.GetItemObject(Column.TR_ETC.ITEM);     // 기타 내역 받아 오기
                foreach (Column.TR_ETC.DATA cEtcItem in alEtcItem)
                {
                    if (cEtcItem.CANCEL_DIV == PosConst.CANCEL_DIV.CANCEL) continue;

                    // OKCASHBACK
                    if (cEtcItem.ETC_WAY_CD == ItemConst.TR_ITEM_ID.ETC_INFO_ITEM && cEtcItem.ETC_DTL_CD_01 == ItemConst.TR_ITEM_ID.ETC_INFO.OCB_SAVE) return sRet;
                    // HP
                    if (cEtcItem.ETC_WAY_CD == ItemConst.TR_ITEM_ID.ETC_INFO_ITEM && cEtcItem.ETC_DTL_CD_01 == ItemConst.TR_ITEM_ID.ETC_INFO.SAVEPOINT) return sRet;
                }

                if (sInPutData == "") return sRet;

                // 해피포인트 조회
                string[] saRecvdData = null;
                sRet = SearchPayment(new string[] { sInPutType, sInPutData, sInEncData, "0", "", sInOrgData }, ref saRecvdData);
                if (sRet != UserCom.RST_OK) return sRet;

                // 해피포인트 아이템 설정
                m_cEtcItem.SEQ = alEtcItem.Count + 1;
                alEtcItem.Add(m_cEtcItem);

                m_cDataService.UpdatePluAmount();       // 상품 합계금액 계산(거래해더)
                m_cDataService.UpdatePayAmount();       // 결제 금액 재 계산 처리

                sRet = UserCom.RST_OK;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                   System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            return sRet;
        }
        #endregion

        #region SetCoopPayment 해피포인트 제휴카드 등록(MSR 일때만 사용)
        /// <summary>
        /// 해피포인트 제휴카드 등록
        /// </summary>
        /// <param name="aParam"></param>
        /// <returns></returns>
        public string SetCoopPayment(string[] aParam)
        {
            string sRet = UserCom.RST_ERR;
            string sInPutType = "", sInPutData = "";

            try
            {
                // 해피포인트 제휴카드 등록 시 해피포인트 업무 옵션 체크(2017.09.08)
                ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                // 해피 포인트 적립 처리
                ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                if (PosMstManager.GetPosOption(POS_OPTION.OPT316) == "0") return sRet;           // 해피포인트 업무 사용 여부(0:사용안함, 1:사용함(한국), 2:사용함(중국))
                //if (PosMstManager.GetPosOption(POS_OPTION.OPT030) == "0") return sRet;           // HP 자동적립 처리(0:사용안함, 1:사용함)

                sInPutType = aParam[0];                         // 입력구분
                sInPutData = aParam[1];                         // 카드데이터

                // 결제할인 마스터의 결제할인 중복 가능 여부 체크
                if (m_cDataCommon.PayDcDuplicationCheck(ItemConst.TR_ITEM_ID.ETC_INFO_ITEM, ItemConst.TR_ITEM_ID.ETC_INFO.SAVEPOINT, false) == false) return sRet;

                // 해피포인트 카드 기등록 여부 체크
                ArrayList alEtcItem = (ArrayList)StateObject.GetItemObject(Column.TR_ETC.ITEM);     // 기타 내역 받아 오기
                foreach (Column.TR_ETC.DATA cEtcItem in alEtcItem)
                {
                    if (cEtcItem.CANCEL_DIV == PosConst.CANCEL_DIV.CANCEL) continue;

                    // OKCASHBACK
                    if (cEtcItem.ETC_WAY_CD == ItemConst.TR_ITEM_ID.ETC_INFO_ITEM && cEtcItem.ETC_DTL_CD_01 == ItemConst.TR_ITEM_ID.ETC_INFO.OCB_SAVE) return sRet;
                    // HP
                    if (cEtcItem.ETC_WAY_CD == ItemConst.TR_ITEM_ID.ETC_INFO_ITEM && cEtcItem.ETC_DTL_CD_01 == ItemConst.TR_ITEM_ID.ETC_INFO.SAVEPOINT) return sRet;
                }

                if ( sInPutData == "")
                {
                    bool bCoopCardExist = false;
                    IMasterUs cMstPayDcService = (IMasterUs)sManager.InitServiceInstance(ServiceLists.ASV_MASTER.DLL, ServiceLists.ASV_MASTER.PAY_DC_MASTER);
                
                    // 제휴카드 해피포포인트 적립 처리
                    ArrayList alPayment = (ArrayList)StateObject.GetItemObject(Column.TR_PAYMENT.ITEM);
                    foreach (Column.TR_PAYMENT.DATA cPayItem in alPayment)
                    {
                        if (cPayItem.CANCEL_DIV == PosConst.CANCEL_DIV.CANCEL) continue;
                        if (cPayItem.PAY_WAY_CD != ItemConst.TR_ITEM_ID.CREDITCARD_ITEM || cPayItem.PAY_DTL_CD_01 != ItemConst.TR_ITEM_ID.CREDITCARD.CREDIT_CARD) continue;

                        // 제휴카드 체크
                        //if (cPayItem.PAY_DTL_CD_03 != "M")
                       //{
                        string sCardNo = cPayItem.OCCUR_ENTRY_01;
                        if (sCardNo.Length <= 5) continue;

                        // 해피포인트 제휴카드 체크
                        DataTable dtCardInfo = cMstPayDcService.Select(new string[] { PosMst.MST_CARD_PREFIX.TABLE_NAME, sCardNo.Substring(0, 6), "H" });
                        if (dtCardInfo != null && dtCardInfo.Rows.Count > 0)
                        {
                            foreach (DataRow dr in dtCardInfo.Rows)
                            {
                                int nLoc = CmUtil.GetDataRowInt(dr, PosMst.MST_CARD_PREFIX.DATA.LOC);
                                string sCheckValue = CmUtil.GetDataRowStr(dr, PosMst.MST_CARD_PREFIX.DATA.CHECK_VAL).Trim();

                                if (nLoc > 0 && sCheckValue.Trim() != "")
                                {
                                    if (CmUtil.MidH(sCardNo, nLoc - 1, sCheckValue.Length) == sCheckValue)
                                    {
                                        bCoopCardExist = true;
                                        break;
                                    }
                                }
                                else
                                {
                                    bCoopCardExist = true;
                                    break;
                                }
                            }
                        }
                        //}

                        // 마이원카드 이거나 제휴카드 이면 
                        // MoonSeokWoo 2017.09.26 마이원 카드 제약조건 제거
                        //if (cPayItem.PAY_DTL_CD_03 == "M" || bCoopCardExist == true)
                        if (bCoopCardExist == true)
                        {
                            sInPutType = cPayItem.OCCUR_ENTRY_05;       // 입력구분
                            sInPutData = cPayItem.CanFiller1;           // 카드데이터
                            break;
                        }
                    }
                }

                if (sInPutData == "") return sRet;

                // 해피포인트 조회
                string[] saRecvdData = null;
                sRet = SearchPayment(new string[] { sInPutType, sInPutData.Substring(0, 6) + "**********", sInPutData, "0", "", sInPutData }, ref saRecvdData);
                if (sRet != UserCom.RST_OK) return sRet;

                // 조회 데이터 획득
                m_cEtcItem = (Column.TR_ETC.DATA)GetPayment(new string[] { });
                if (sInPutData.StartsWith(PosConst.HP_CARD_PRIFIX) == false && m_cEtcItem.HP_ADD_INFO_SCH.Trim() != "")     // 제휴카드 조회
                {
                    int nNowPos = 0;
                    string[] aIrtRsp = new string[Column.POINT_ADD_INFO_SEARCH.LEN.Length];
                    ItemColumn.ParseMessage(Column.POINT_ADD_INFO_SEARCH.LEN, Column.POINT_ADD_INFO_SEARCH.TYPE, Encoding.Default.GetBytes(m_cEtcItem.HP_ADD_INFO_SCH), ref nNowPos, ref aIrtRsp);

                    // 고객정보 중에서 첫번째 카드 선택
                    string sMemInfo = aIrtRsp[Column.POINT_ADD_INFO_SEARCH.SEQ.pointMEMINFO].Trim();
                    if (sMemInfo.Length >= 17 && CmUtil.LongParse(sMemInfo.Substring(0, 1)) > 0)
                    {
                        string sInPutDatatmp = sMemInfo.Substring(1, 16).Trim();        // 카드번호 

                        m_cEtcItem.CanFiller1 = sInPutDatatmp;

                        m_cEtcItem.OCCUR_ENTRY_14 = sInPutDatatmp;        // 승인카드번호
                    }
                }

                m_cEtcItem.CanFiller3 = sInPutData;

                // 해피포인트 아이템 설정
                m_cEtcItem.SEQ = alEtcItem.Count + 1;
                alEtcItem.Add(m_cEtcItem);

                m_cDataService.UpdatePluAmount();       // 상품 합계금액 계산(거래해더)
                m_cDataService.UpdatePayAmount();       // 결제 금액 재 계산 처리

                sRet = UserCom.RST_OK;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                   System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            return sRet;
        }
        #endregion


        #region SetCoopPaymentIC 해피포인트 제휴카드 등록(IC 일때만 사용)
        /// <summary>
        /// 해피포인트 제휴카드 등록
        /// </summary>
        /// <param name="aParam"></param>
        /// <returns></returns>
        public string SetCoopPaymentIC(string[] aParam)
        {
            string sRet = UserCom.RST_ERR;
            string sInPutType = "", sInPutData = "", sInMaskData = "" ;
            //#15183 보안리더기 삼성페이 해피포인트 자동적립 기능 수정 start,phj
            string sInMobileCode = "";
            //#15183 보안리더기 삼성페이 해피포인트 자동적립 기능 수정 end,phj

            try
            {
                // 해피포인트 제휴카드 등록 시 해피포인트 업무 옵션 체크(2017.09.08)
                ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                // 해피 포인트 적립 처리
                ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                if (PosMstManager.GetPosOption(POS_OPTION.OPT316) == "0") return sRet;           // 해피포인트 업무 사용 여부(0:사용안함, 1:사용함(한국), 2:사용함(중국))
                //if (PosMstManager.GetPosOption(POS_OPTION.OPT030) == "0") return sRet;           // HP 자동적립 처리(0:사용안함, 1:사용함)

                sInPutType = aParam[0];                         // 입력구분
                sInPutData = aParam[1];                         // 카드데이터

                //#15183 보안리더기 삼성페이 해피포인트 자동적립 기능 수정 start,phj
                sInMobileCode = aParam.Length >= 3 ? aParam[2] : ""; //aParam[2];
                //#15183 보안리더기 삼성페이 해피포인트 자동적립 기능 수정 end,phj

                // 결제할인 마스터의 결제할인 중복 가능 여부 체크
                if (m_cDataCommon.PayDcDuplicationCheck(ItemConst.TR_ITEM_ID.ETC_INFO_ITEM, ItemConst.TR_ITEM_ID.ETC_INFO.SAVEPOINT, false) == false) return sRet;

                // 해피포인트 카드 기등록 여부 체크
                ArrayList alEtcItem = (ArrayList)StateObject.GetItemObject(Column.TR_ETC.ITEM);     // 기타 내역 받아 오기
                foreach (Column.TR_ETC.DATA cEtcItem in alEtcItem)
                {
                    if (cEtcItem.CANCEL_DIV == PosConst.CANCEL_DIV.CANCEL) continue;

                    // OKCASHBACK
                    if (cEtcItem.ETC_WAY_CD == ItemConst.TR_ITEM_ID.ETC_INFO_ITEM && cEtcItem.ETC_DTL_CD_01 == ItemConst.TR_ITEM_ID.ETC_INFO.OCB_SAVE) return sRet;
                    // HP
                    if (cEtcItem.ETC_WAY_CD == ItemConst.TR_ITEM_ID.ETC_INFO_ITEM && cEtcItem.ETC_DTL_CD_01 == ItemConst.TR_ITEM_ID.ETC_INFO.SAVEPOINT) return sRet;
                }

                if (sInPutData == "")
                {
                    bool bCoopCardExist = false;
                    IMasterUs cMstPayDcService = (IMasterUs)sManager.InitServiceInstance(ServiceLists.ASV_MASTER.DLL, ServiceLists.ASV_MASTER.PAY_DC_MASTER);

                    // 제휴카드 해피포포인트 적립 처리
                    ArrayList alPayment = (ArrayList)StateObject.GetItemObject(Column.TR_PAYMENT.ITEM);
                    foreach (Column.TR_PAYMENT.DATA cPayItem in alPayment)
                    {
                        if (cPayItem.CANCEL_DIV == PosConst.CANCEL_DIV.CANCEL) continue;
                        if (cPayItem.PAY_WAY_CD != ItemConst.TR_ITEM_ID.CREDITCARD_ITEM || cPayItem.PAY_DTL_CD_01 != ItemConst.TR_ITEM_ID.CREDITCARD.CREDIT_CARD) continue;

                        // 제휴카드 체크
                        //if (cPayItem.PAY_DTL_CD_03 != "M")
                        //{
                        string sCardNo = cPayItem.OCCUR_ENTRY_01;
                        sInMaskData = sCardNo;
                        if (sCardNo.Length <= 5) continue;


                        //#15183 보안리더기 삼성페이 해피포인트 자동적립 기능 수정 start,phj
                        //기존
                        /*
                        // 해피포인트 제휴카드 체크
                        DataTable dtCardInfo = cMstPayDcService.Select(new string[] { PosMst.MST_CARD_PREFIX.TABLE_NAME, sCardNo.Substring(0, 6), "H" });
                        if (dtCardInfo != null && dtCardInfo.Rows.Count > 0)
                        {
                            foreach (DataRow dr in dtCardInfo.Rows)
                            {
                                int nLoc = CmUtil.GetDataRowInt(dr, PosMst.MST_CARD_PREFIX.DATA.LOC);
                                string sCheckValue = CmUtil.GetDataRowStr(dr, PosMst.MST_CARD_PREFIX.DATA.CHECK_VAL).Trim();

                                if (nLoc > 0 && sCheckValue.Trim() != "")
                                {
                                    if (CmUtil.MidH(sCardNo, nLoc - 1, sCheckValue.Length) == sCheckValue)
                                    {
                                        bCoopCardExist = true;
                                        break;
                                    }
                                }
                                else
                                {
                                    bCoopCardExist = true;
                                    break;
                                }
                            }
                        }
                        */

                        //변경
                        if (sInMobileCode == "HAPPY93")
                        {
                            bCoopCardExist = true;
                        }
                        else
                        {
                            DataTable dtCardInfo = cMstPayDcService.Select(new string[] { PosMst.MST_CARD_PREFIX.TABLE_NAME, sCardNo.Substring(0, 6), "H" });
                            if (dtCardInfo != null && dtCardInfo.Rows.Count > 0)
                            {
                                foreach (DataRow dr in dtCardInfo.Rows)
                                {
                                    int nLoc = CmUtil.GetDataRowInt(dr, PosMst.MST_CARD_PREFIX.DATA.LOC);
                                    string sCheckValue = CmUtil.GetDataRowStr(dr, PosMst.MST_CARD_PREFIX.DATA.CHECK_VAL).Trim();

                                    if (nLoc > 0 && sCheckValue.Trim() != "")
                                    {
                                        if (CmUtil.MidH(sCardNo, nLoc - 1, sCheckValue.Length) == sCheckValue)
                                        {
                                            bCoopCardExist = true;
                                            break;
                                        }
                                    }
                                    else
                                    {
                                        bCoopCardExist = true;
                                        break;
                                    }
                                }
                            }
                        }
                        //#15183 보안리더기 삼성페이 해피포인트 자동적립 기능 수정 end,phj
                        
                        //}

                        // 마이원카드 이거나 제휴카드 이면 
                        // MoonSeokWoo 2017.09.26 마이원 카드 제약조건 제거
                        //if (cPayItem.PAY_DTL_CD_03 == "M" || bCoopCardExist == true)
                        if (bCoopCardExist == true)
                        {
                            sInPutType = cPayItem.OCCUR_ENTRY_05;       // 입력구분
                            sInPutData = cPayItem.CanFiller1;           // 카드데이터
                            break;
                        }
                    }
                }

                if (sInPutData == "") return sRet;

                // 해피포인트 조회
                string[] saRecvdData = null;
                sRet = SearchPayment(new string[] { sInPutType, sInMaskData.Substring(0, 6) + "**********", sInPutData, "0", "", sInPutData }, ref saRecvdData);
                if (sRet != UserCom.RST_OK) return sRet;

                // 조회 데이터 획득
                m_cEtcItem = (Column.TR_ETC.DATA)GetPayment(new string[] { });
                if (sInPutData.StartsWith(PosConst.HP_CARD_PRIFIX) == false && m_cEtcItem.HP_ADD_INFO_SCH.Trim() != "")     // 제휴카드 조회
                {
                    int nNowPos = 0;
                    string[] aIrtRsp = new string[Column.POINT_ADD_INFO_SEARCH.LEN.Length];
                    ItemColumn.ParseMessage(Column.POINT_ADD_INFO_SEARCH.LEN, Column.POINT_ADD_INFO_SEARCH.TYPE, Encoding.Default.GetBytes(m_cEtcItem.HP_ADD_INFO_SCH), ref nNowPos, ref aIrtRsp);

                    // 고객정보 중에서 첫번째 카드 선택
                    string sMemInfo = aIrtRsp[Column.POINT_ADD_INFO_SEARCH.SEQ.pointMEMINFO].Trim();
                    if (sMemInfo.Length >= 17 && CmUtil.LongParse(sMemInfo.Substring(0, 1)) > 0)
                    {
                        string sInPutDatatmp =  sMemInfo.Substring(1, 16).Trim();        // 카드번호 

                        string temp = m_cDeviceICReader.GetEncryptedCardNo(sInPutDatatmp, "0").Trim();

                        m_cEtcItem.CanFiller1 = CmUtil.MidH(temp, 2, 512).Trim();
                            
                        m_cEtcItem.OCCUR_ENTRY_14 = sInPutDatatmp;        // 승인카드번호
                    }
                }

                //#20180309 해피포인트 제휴카드 결제 후 현금영수증창에 암호화된 카드번호 표시되는 오류 수정 start
                //해피포인트 제휴카드는 현금영수증창에 해피포인트 번호 미표시
                //기존
                //m_cEtcItem.CanFiller3 = sInPutData;
                //#20180309 해피포인트 제휴카드 결제 후 현금영수증창에 암호화된 카드번호 표시되는 오류 수정 end

                // 해피포인트 아이템 설정
                m_cEtcItem.SEQ = alEtcItem.Count + 1;
                alEtcItem.Add(m_cEtcItem);

                m_cDataService.UpdatePluAmount();       // 상품 합계금액 계산(거래해더)
                m_cDataService.UpdatePayAmount();       // 결제 금액 재 계산 처리

                sRet = UserCom.RST_OK;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                   System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            return sRet;
        }
        #endregion

        //#20180329, 해피기프트(신) 자동적립 수정 Start, lsr
        #region SetHPGiftPayment 해피기프트(신) 해피포인트 등록.
        /// <summary>
        /// 해피기프트(신) 해피포인트 등록.
        /// </summary>
        /// <returns></returns>
        public string SetHPGiftPayment()
        {
            string sRet = UserCom.RST_ERR;
            string sInPutType = ""; // 입력구분
            string sInPutData = ""; // 마스킹데이터
            string sInEncData = ""; // 암호화 데이터
            string sInOrgData = ""; // 입력카드데이터

            try
            {
                // 해피포인트 제휴카드 등록 시 해피포인트 업무 옵션 체크(2017.09.08)
                ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                // 해피 포인트 적립 처리
                ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                if (PosMstManager.GetPosOption(POS_OPTION.OPT316) == "0") return sRet;           // 해피포인트 업무 사용 여부(0:사용안함, 1:사용함(한국), 2:사용함(중국))
                //if (PosMstManager.GetPosOption(POS_OPTION.OPT030) == "0") return sRet;           // HP 자동적립 처리(0:사용안함, 1:사용함)

                // 결제할인 마스터의 결제할인 중복 가능 여부 체크
                if (m_cDataCommon.PayDcDuplicationCheck(ItemConst.TR_ITEM_ID.ETC_INFO_ITEM, ItemConst.TR_ITEM_ID.ETC_INFO.SAVEPOINT, false) == false) return sRet;

                // 해피포인트 카드 기등록 여부 체크
                ArrayList alEtcItem = (ArrayList)StateObject.GetItemObject(Column.TR_ETC.ITEM);     // 기타 내역 받아 오기
                foreach (Column.TR_ETC.DATA cEtcItem in alEtcItem)
                {
                    if (cEtcItem.CANCEL_DIV == PosConst.CANCEL_DIV.CANCEL) continue;

                    // OKCASHBACK
                    if (cEtcItem.ETC_WAY_CD == ItemConst.TR_ITEM_ID.ETC_INFO_ITEM && cEtcItem.ETC_DTL_CD_01 == ItemConst.TR_ITEM_ID.ETC_INFO.OCB_SAVE) return sRet;
                    // HP
                    if (cEtcItem.ETC_WAY_CD == ItemConst.TR_ITEM_ID.ETC_INFO_ITEM && cEtcItem.ETC_DTL_CD_01 == ItemConst.TR_ITEM_ID.ETC_INFO.SAVEPOINT) return sRet;
                }


                // 해피기프트(신) 해피포인트 적립
                ArrayList alPayment = (ArrayList)StateObject.GetItemObject(Column.TR_PAYMENT.ITEM);
                foreach (Column.TR_PAYMENT.DATA cPayItem in alPayment)
                {
                    if (cPayItem.CANCEL_DIV == PosConst.CANCEL_DIV.CANCEL) continue;
                    if (cPayItem.PAY_WAY_CD != ItemConst.TR_ITEM_ID.PPCARD_ITEM || cPayItem.PAY_DTL_CD_01 != ItemConst.TR_ITEM_ID.PPCARD.HPGIFT_CARD) continue;

                    string sCardNo = cPayItem.CanFiller2;
                    if (sCardNo.Length <= 5) continue;

                    sInPutType = cPayItem.OCCUR_ENTRY_05;       // 입력구분
                    sInPutData = sCardNo.Substring(0, 6) + "**********";
                    sInOrgData = sCardNo;                      

                    string temp = m_cDeviceICReader.GetEncryptedCardNo(sCardNo, "0").Trim();
                    sInEncData = CmUtil.MidH(temp, 2, 512).Trim(); // 카드데이터
   
                            
                    break;
                }

                if (sInPutData == "") return sRet;

                // 해피포인트 조회
                string[] saRecvdData = null;
                sRet = SearchPayment(new string[] { sInPutType, sInPutData, sInEncData, "0", "", sInOrgData }, ref saRecvdData);
                if (sRet != UserCom.RST_OK) return sRet;

                // 해피포인트 아이템 설정
                m_cEtcItem.SEQ = alEtcItem.Count + 1;
                alEtcItem.Add(m_cEtcItem);

                m_cDataService.UpdatePluAmount();       // 상품 합계금액 계산(거래해더)
                m_cDataService.UpdatePayAmount();       // 결제 금액 재 계산 처리

                sRet = UserCom.RST_OK;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                   System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            return sRet;
        }
        #endregion
        //#20180329, 해피기프트(신) 자동적립 수정 End, lsr

        #region 해피포인트 조회 실행
        /// <summary>
        /// 해피포인트 조회 실행
        /// </summary>
        public string ExecutePointHappyPointIrt(string sTradeDiv, string sTrType, string sPointType, string sInPutType, string sInPutData, string sInEncData
            , double nNetSaleAmt, double nBasicSaveAmt, string sAddSaveInfo, string sCampaingInfo
            , string sApprDate, string sApprNo)
        {
            string sRet = UserCom.RST_ERR;
            try
            {
                if (sInPutData.Length >= 6) sInPutData = sInPutData.Substring(0, 6).PadRight(sInPutData.Length, '*');

                // 연습모드이면 연습 데이터 설정
                if (m_cPosStatus.Base.TrainingFlag == "1" || m_cPosStatus.Mst.TestStorYn == "1" ) return SetTrainingData(sTrType, sPointType, sInPutType, sInPutData, sInEncData, nNetSaleAmt, nBasicSaveAmt, sApprDate, sApprNo);

                string sAddInfo = "";
                if (sTrType == PosConst.POS_VAN_MASTER.TRADE_ID.VAN_POT_QRY_A)      
                {
                    //#해피앱 추후적립 start, sskim
                    //해피앱에서 추후적립한 적립건은 조회전문으로 승인취소.
                    // 조회
                    //기존
                    /*
                    sAddInfo += CmUtil.RPadH("", 10);                           // 요청 사용자 ID                               
                    sAddInfo += CmUtil.RPadH(m_cPosStatus.Base.StoreNo, 10);    // 점포코드
                    sAddInfo += CmUtil.RPadH(m_cPosStatus.Base.PosNo, 2);       // 포스번호
                    sAddInfo += CmUtil.RPadH("", 178);                          // VReserved
                    */
                    //변경
                    if (m_cEtcItem.OCCUR_ENTRY_22 == "1")
                    {
                        sAddInfo += CmUtil.RPadH("", 10);                                           // 요청 사용자 ID                               
                        sAddInfo += CmUtil.RPadH("30", 2);                                          // 요청구분코드
                        sAddInfo += CmUtil.RPadH(sApprDate, 8);                                     // Filler -> 원거래승인일자
                        sAddInfo += ",";                                                            // Filler -> 원거래승인일자
                        sAddInfo += CmUtil.RPadH(sApprNo, 12);                                      // Filler -> 원거래승인번호
                        sAddInfo += ",";                                                            // Filler -> 원거래승인일자
                        sAddInfo += CmUtil.RPadH(string.Format("{0:D9}", (long)nBasicSaveAmt), 9);  // Filler -> 포인트금액
                        //#20170628 start PHJ
                        //기존
                        //sAddInfo += CmUtil.RPadH("", 131);                                          // Filler
                        //변경
                        sAddInfo += CmUtil.RPadH("", 129);                                          // Filler
                        //#20170628 end PHJ
                        sAddInfo += CmUtil.RPadH("", 28);                                           // VReserved
                        
                    }
                    else
                    {
                        sAddInfo += CmUtil.RPadH("", 10);                           // 요청 사용자 ID                               
                        sAddInfo += CmUtil.RPadH(m_cPosStatus.Base.StoreNo, 10);    // 점포코드
                        sAddInfo += CmUtil.RPadH(m_cPosStatus.Base.PosNo, 2);       // 포스번호
                        sAddInfo += CmUtil.RPadH("", 178);                          // VReserved
                    }
                    //#해피앱 추후적립 end, sskim
                }
                else if (sTrType == PosConst.POS_VAN_MASTER.TRADE_ID.VAN_POT_ACC_A || sTrType == PosConst.POS_VAN_MASTER.TRADE_ID.VAN_POT_ACC_C)
                {
                    // 적립,적립취소
                    sAddInfo += CmUtil.RPadH("", 10);                           // 요청 사용자 ID
                    sAddInfo += CmUtil.RPadH(m_cPosStatus.Base.SaleDate, 8);    // POS 영업일자 - POS 매출일자 8자리
                    sAddInfo += "1001";                                         // 거래사유코드 - 1001:대금결제, 1002:포인트고객적립, 1003:운영사이벤트, 1004:제휴사 이벤트
                    sAddInfo += CmUtil.RPadH(m_cPosStatus.Base.SaleDate, 10);   // SAP 코드 - POS 매출일자 10자리
                    sAddInfo += CmUtil.RPadH(m_cPosStatus.Base.PosNo, 2);       // POS 번호
                    sAddInfo += "10";                                           // 요청구분 - 10:일반적립, 20:캐시포인트적립
                    sAddInfo += "10";                                           // 적립방식구분코드 - 10:즉시적립, 20:영수증추후적립                    
                    sAddInfo += string.Format("{0:D10}", (long)nBasicSaveAmt);  // 총적립대상금액
                    sAddInfo += "0000000";                                      // 캐시포인트 - 고객이 현금을 캐쉬로 적립 요청한 경우 적립할 캐시포인트
                    sAddInfo += CmUtil.RPadH("", 20);                           // 결제카드번호 - 신용 결제한 카드번호
                    sAddInfo += CmUtil.RPadH("", 125); ;                        // VReserved
                }

                string sVanCD = GetPayDtlCdToVanCode(m_cEtcItem.ETC_WAY_CD, m_cEtcItem.ETC_DTL_CD_01);    // 승인업체 코드 조회
                if (sVanCD == "")
                {
                    if (m_bErrMsgShow) WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0563);
                    return sRet;
                }
                // 포인트 조회
                string[] aIrtRsp = null;

                //#해피앱 추후적립 start, sskim
                //해피앱 추후적립 여부 추가로 넘긴다.
                //기존
                //sRet = ExecutePointIrt(sTradeDiv, m_cEtcItem.ETC_WAY_CD, m_cEtcItem.ETC_DTL_CD_01, sVanCD, sTrType, sPointType, sInPutType, sInPutData, sInEncData, nNetSaleAmt, sApprDate, sApprNo, "", "", sAddSaveInfo, sCampaingInfo, sAddInfo, ref aIrtRsp, "", m_cEtcItem.OCCUR_ENTRY_10);
                //변경
                if (m_cEtcItem.OCCUR_ENTRY_22 == "1")
                {
                    sRet = ExecutePointIrt(sTradeDiv, m_cEtcItem.ETC_WAY_CD, m_cEtcItem.ETC_DTL_CD_01, sVanCD, sTrType, sPointType, sInPutType, sInPutData, sInEncData, nNetSaleAmt, sApprDate, sApprNo, "", "", sAddSaveInfo, sCampaingInfo, sAddInfo, ref aIrtRsp, "", m_cEtcItem.OCCUR_ENTRY_10, m_cEtcItem.OCCUR_ENTRY_22, m_bErrMsgShow);
                }
                else
                {
                    sRet = ExecutePointIrt(sTradeDiv, m_cEtcItem.ETC_WAY_CD, m_cEtcItem.ETC_DTL_CD_01, sVanCD, sTrType, sPointType, sInPutType, sInPutData, sInEncData, nNetSaleAmt, sApprDate, sApprNo, "", "", sAddSaveInfo, sCampaingInfo, sAddInfo, ref aIrtRsp, "", m_cEtcItem.OCCUR_ENTRY_10, string.Empty, m_bErrMsgShow);
                }
                //#해피앱 추후적립 end, sskim

                if (sRet != UserCom.RST_OK) return sRet;

                if (sTradeDiv == PosConst.CANCEL_DIV.NORMAL)
                {
                    m_cEtcItem.ETC_DTL_CD_05 = PosConst.PAY_DC_TYPE.NORMAL;                                         // 할인결제구분 (1:결제, 2:할인)

                    m_cEtcItem.ETC_AMT = CmUtil.DoubleParse(aIrtRsp[Column.POS_RES_POINT.SEQ.ResTrPoint]);          // 적립포인트
                    m_cEtcItem.AMT_ENTRY_01 = CmUtil.DoubleParse(aIrtRsp[Column.POS_RES_POINT.SEQ.ResTrPoint]);     // 적립포인트     
                    m_cEtcItem.AMT_ENTRY_03 = CmUtil.DoubleParse(aIrtRsp[Column.POS_RES_POINT.SEQ.ResSavePoint]);   // 총포인트(누적포인트)
                    if (sTrType == PosConst.POS_VAN_MASTER.TRADE_ID.VAN_POT_QRY_A)
                        m_cEtcItem.AMT_ENTRY_04 = CmUtil.DoubleParse(aIrtRsp[Column.POS_RES_POINT.SEQ.ResUsesPoint]);   // 가용포인트
                    m_cEtcItem.AMT_ENTRY_05 = CmUtil.DoubleParse(aIrtRsp[Column.POS_RES_POINT.SEQ.ResSavePoint]);   // 누적포인트
                    m_cEtcItem.AMT_ENTRY_08 = nBasicSaveAmt;            // 적립대상금액1(기본적립)

                    m_cEtcItem.OCCUR_ENTRY_01 = sInPutData.Length > 16 ? sInPutData.Substring(0, 16) : sInPutData;  // 카드번호
                    m_cEtcItem.OCCUR_ENTRY_02 = aIrtRsp[Column.POS_RES_POINT.SEQ.ResApprNo].Trim();                 // 승인번호
                    m_cEtcItem.OCCUR_ENTRY_03 = CmUtil.MidH(aIrtRsp[Column.POS_RES_POINT.SEQ.ResTrDate], 0, 6);     // 승인일자
                    m_cEtcItem.OCCUR_ENTRY_04 = CmUtil.MidH(aIrtRsp[Column.POS_RES_POINT.SEQ.ResTrDate], 6, 4);     // 승인시간
                    m_cEtcItem.OCCUR_ENTRY_05 = sInPutType;             // 입력 구분
                    m_cEtcItem.OCCUR_ENTRY_06 = sApprNo;                // 원승인번호
                    m_cEtcItem.OCCUR_ENTRY_07 = sApprDate;              // 원승인일자
                    m_cEtcItem.OCCUR_ENTRY_08 = ItemConst.PAY_APP_DIV.NORMAL;   //승인구분
                    m_cEtcItem.OCCUR_ENTRY_09 = "0";                    // 거래후 적립 구분(0:일반, 1:사후)
                    m_cEtcItem.OCCUR_ENTRY_16 = sVanCD;                 // VAN 구분
                    m_cEtcItem.OCCUR_ENTRY_18 = aIrtRsp[Column.POS_RES_POINT.SEQ.ResStoreNo];                       // 가맹점번호
                    m_cEtcItem.OCCUR_ENTRY_20 = GetPayDtlCdToPayDtlName(m_cEtcItem.ETC_WAY_CD, m_cEtcItem.ETC_DTL_CD_01);   // 결제수단명
                    m_cEtcItem.OCCUR_ENTRY_21 = GetPayDtlCdToCashBillYn(m_cEtcItem.ETC_WAY_CD, m_cEtcItem.ETC_DTL_CD_01);   // 현금영수증 발행여부

                    m_cEtcItem.CANCEL_DIV = ItemConst.PAY_CANCEL_DIV.NORMAL;
                    m_cEtcItem.BILLSPR_NO = m_cTrnStatus.Sale.BillSplitNo;      // 빌분리 번호

                    m_cEtcItem.CanFiller1 = sInEncData;

                    m_cEtcItem.HP_RESERVED = aIrtRsp[Column.POS_RES_POINT.SEQ.ResReserved].Trim();      // 예약필드
                    m_cEtcItem.HP_CAMPAIGN_INFO = aIrtRsp[Column.POS_RES_POINT.SEQ.ResCampaign].Trim(); // 캠페인정보

                    if (sTrType == PosConst.POS_VAN_MASTER.TRADE_ID.VAN_POT_QRY_A)
                        m_cEtcItem.HP_ADD_INFO_SCH = aIrtRsp[Column.POS_RES_POINT.SEQ.ResAddRespon].Trim();     // 추가응답정보
                    else
                        m_cEtcItem.HP_ADD_INFO_SAVE = aIrtRsp[Column.POS_RES_POINT.SEQ.ResAddRespon].Trim();    // 추가응답정보

                    //#20171017 전자영수증 발행 start, phj
                    if (sTrType == PosConst.POS_VAN_MASTER.TRADE_ID.VAN_POT_QRY_A)
                    {
                        if (m_cEtcItem.HP_ADD_INFO_SCH != "")
                        {
                            m_cEtcItem.OCCUR_ENTRY_23 = CmUtil.MidH(m_cEtcItem.HP_ADD_INFO_SCH, 144, 1).Trim();
                        }
                    }
                    //#20171017 전자영수증 발행 end, phj   

                    //#20180413 웰컴카드 신규기능 추가 start,phj

                    //string HP_WelcomeCard = "";
                    //HP_WelcomeCard = aIrtRsp[Column.POINT_ADD_INFO_SEARCH.SEQ.pointRESERVED].Trim();
                    //if (HP_WelcomeCard != "") { HP_WelcomeCard = CmUtil.MidH(HP_WelcomeCard, 0, 20).Trim(); }
                    //m_cEtcItem.OCCUR_ENTRY_19 = HP_WelcomeCard; // CmUtil.MidH(HP_WelcomeCard, 0, 50).Trim(); // 웰컴카드번호   
                   
                    if (sTrType == PosConst.POS_VAN_MASTER.TRADE_ID.VAN_POT_QRY_A)
                    {
                        int t_nNowPos = 0;
                        string[] t_aIrtRsp = null;
                        t_aIrtRsp = new string[Column.POINT_ADD_INFO_SEARCH.LEN.Length];
                        byte[] t_bytes = Encoding.Default.GetBytes(m_cEtcItem.HP_ADD_INFO_SCH);
                        ItemColumn.ParseMessage(Column.POINT_ADD_INFO_SEARCH.LEN, Column.POINT_ADD_INFO_SEARCH.TYPE, t_bytes, ref t_nNowPos, ref t_aIrtRsp);

                        string HP_WelcomeCard = "";
                        HP_WelcomeCard = t_aIrtRsp[Column.POINT_ADD_INFO_SEARCH.SEQ.pointRESERVED].Trim();
                        HP_WelcomeCard = CmUtil.MidH(HP_WelcomeCard, 0, 20).Trim();
                        m_cEtcItem.OCCUR_ENTRY_19 = HP_WelcomeCard; // 웰컴카드번호
                    }
   
                    //#20180413 웰컴카드 신규기능 추가 end,phj 
                }
                else
                {
                    m_cEtcItem.AMT_ENTRY_03 = CmUtil.DoubleParse(aIrtRsp[Column.POS_RES_POINT.SEQ.ResSavePoint]);   // 총포인트(누적포인트)
                    m_cEtcItem.AMT_ENTRY_05 = CmUtil.DoubleParse(aIrtRsp[Column.POS_RES_POINT.SEQ.ResSavePoint]);   // 누적포인트

                    m_cEtcItem.OCCUR_ENTRY_01 = sInPutData.Length > 16 ? sInPutData.Substring(0, 16) : sInPutData;  // 카드번호
                    m_cEtcItem.OCCUR_ENTRY_02 = aIrtRsp[Column.POS_RES_POINT.SEQ.ResApprNo].Trim();                 // 승인번호
                    m_cEtcItem.OCCUR_ENTRY_03 = CmUtil.MidH(aIrtRsp[Column.POS_RES_POINT.SEQ.ResTrDate], 0, 6);     // 승인일자
                    m_cEtcItem.OCCUR_ENTRY_04 = CmUtil.MidH(aIrtRsp[Column.POS_RES_POINT.SEQ.ResTrDate], 6, 4);     // 승인시간
                    m_cEtcItem.OCCUR_ENTRY_05 = sInPutType;             // 입력 구분
                    m_cEtcItem.OCCUR_ENTRY_06 = sApprNo;                // 원승인번호
                    m_cEtcItem.OCCUR_ENTRY_07 = sApprDate;              // 원승인일자

                    m_cEtcItem.HP_ADD_INFO_SAVE = aIrtRsp[Column.POS_RES_POINT.SEQ.ResAddRespon].Trim();    // 추가응답정보

                    //#해피앱 추후적립 start, sskim
                    //해피앱 추후적립 승인취소시 승인일자, 승인시간, 승인번호, 적립취소포인트, 잔여포인트가 추가정보에 있음.
                    if (m_cEtcItem.OCCUR_ENTRY_22 == "1")
                    {
                        string[] ResAddResponSplit = m_cEtcItem.HP_ADD_INFO_SAVE.Split(new string[] { "," }, StringSplitOptions.None);
                        m_cEtcItem.OCCUR_ENTRY_02 = ResAddResponSplit[2];// 승인번호
                        m_cEtcItem.OCCUR_ENTRY_03 = ResAddResponSplit[0];// 승인일자
                        m_cEtcItem.OCCUR_ENTRY_04 = ResAddResponSplit[1];// 승인시간
                        //#20170629 START PHJ
                        m_cEtcItem.AMT_ENTRY_05 = CmUtil.DoubleParse(ResAddResponSplit[4]);// 잔여포인트
                        //#20170629 END PHJ
                    }
                    //#해피앱 추후적립 end, sskim

                }
                sRet = UserCom.RST_OK;
            }
            catch (Exception ex)
            {
                if (m_bErrMsgShow) WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                    System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            finally
            {
                //여전법 대응!
                //////////////////////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref sInPutData);
                CmUtil.ZeroFillClear(ref sInEncData);
                //////////////////////////////////////////////////////////////////////////////////
            }
            return sRet;
        }

        /// <summary>
        /// 연습 데이터 설정
        /// </summary>
        public string SetTrainingData(string sTrType, string sPointType, string sInPutType, string sInPutData, string sInEncData
            , double nNetSaleAmt, double nBasicSaveAmt, string sApprDate, string sApprNo)
        {
            string sRet = UserCom.RST_ERR;
            try
            {
                // 연습모드이면 연습 데이터 설정
                string sVanCD = GetPayDtlCdToVanCode(m_cEtcItem.ETC_WAY_CD, m_cEtcItem.ETC_DTL_CD_01);    // 승인업체 코드 조회
                if (sVanCD == "")
                {
                    WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0563);
                    return sRet;
                }

                double nSavePnt = 0;
                if (sTrType != PosConst.POS_VAN_MASTER.TRADE_ID.VAN_POT_QRY_A || sTrType != PosConst.POS_CAT_MASTER.TRADE_ID.CAT_HAPPY_SEARCH)
                {
                    nSavePnt = (long)CmUtil.MathRounds(CmUtil.MathAmtPercent(nBasicSaveAmt, m_cPosStatus.Mst.HpyPntAccumRate), PosConst.MATH_ROUND.CEILING, 0);
                    //nSavePnt = m_cDataCommon.ExecTermCoopCmpPayDc(m_cEtcItem.ETC_WAY_CD, m_cEtcItem.ETC_DTL_CD_01, "", nBasicSaveAmt);     // 제휴사 결제 할인 금액 계산
                }

                m_cEtcItem.ETC_DTL_CD_05 = PosConst.PAY_DC_TYPE.NORMAL;         // 할인결제구분 (1:결제, 2:할인)

                m_cEtcItem.ETC_AMT = nSavePnt;
                m_cEtcItem.AMT_ENTRY_01 = nSavePnt;         // 적립포인트
                m_cEtcItem.AMT_ENTRY_03 = 99990;            // 총포인트
                m_cEtcItem.AMT_ENTRY_04 = 99990;            // 가용포인트
                m_cEtcItem.AMT_ENTRY_05 = 0;
                m_cEtcItem.AMT_ENTRY_08 = nNetSaleAmt;      // 적립대상금액

                m_cEtcItem.OCCUR_ENTRY_01 = sInPutData.Length > 16 ? sInPutData.Substring(0, 16) : sInPutData;  // 카드번호
                m_cEtcItem.OCCUR_ENTRY_02 = "99999999";                         // 승인번호
                m_cEtcItem.OCCUR_ENTRY_03 = DateTime.Now.ToString("yyMMdd");    // 승인일자
                m_cEtcItem.OCCUR_ENTRY_04 = DateTime.Now.ToString("HHmm");      // 승인시간
                m_cEtcItem.OCCUR_ENTRY_05 = sInPutType;     // 입력구분
                m_cEtcItem.OCCUR_ENTRY_06 = sApprNo;        // 원승인번호
                m_cEtcItem.OCCUR_ENTRY_07 = sApprDate;         // 원승인일자
                m_cEtcItem.OCCUR_ENTRY_08 = ItemConst.PAY_APP_DIV.COMPULSION;                                           // 승인구분
                m_cEtcItem.OCCUR_ENTRY_09 = "0";            // 거래후 적립 구분(0:일반, 1:사후)
                m_cEtcItem.OCCUR_ENTRY_16 = sVanCD;         // VAN 구분
                m_cEtcItem.OCCUR_ENTRY_18 = "";
                m_cEtcItem.OCCUR_ENTRY_20 = GetPayDtlCdToPayDtlName(m_cEtcItem.ETC_WAY_CD, m_cEtcItem.ETC_DTL_CD_01);   // 결제수단명
                m_cEtcItem.OCCUR_ENTRY_21 = GetPayDtlCdToCashBillYn(m_cEtcItem.ETC_WAY_CD, m_cEtcItem.ETC_DTL_CD_01);   // 현금영수증 발행여부
                
                m_cEtcItem.CANCEL_DIV = ItemConst.PAY_CANCEL_DIV.NORMAL;
                m_cEtcItem.BILLSPR_NO = m_cTrnStatus.Sale.BillSplitNo;              // 빌분리 번호

                m_cEtcItem.CanFiller1 = sInEncData;

                sRet = UserCom.RST_OK;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                    System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            finally
            {
                //여전법 대응!
                //////////////////////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref sInPutData);
                CmUtil.ZeroFillClear(ref sInEncData);
                //////////////////////////////////////////////////////////////////////////////////
            }
            return sRet;
        }
        #endregion

        #region Cat단말기 승인 처리
        /// <summary>
        /// Cat단말기 승인 처리
        /// </summary>
        /// <param name="sAppType"></param>
        /// <param name="aParam"></param>
        /// <returns></returns>
        public string CatExecuteIrt(string sAppType, string[] aParam)
        {

            string sRet = UserCom.RST_ERR;
            
            try
            {
                // 연습모드이면 연습 데이터 설정
                if (m_cPosStatus.Base.TrainingFlag == "1" || m_cPosStatus.Mst.TestStorYn == "1") return SetTrainingData(sAppType, "", "K", "999999*********", "", CmUtil.DoubleParse(aParam[3]), m_cTrnStatus.Head.AftSavePoint, DateTime.Now.ToString("yyyyMMdd"), "99999999");


                string sAddInfo = "";
                if (sAppType == PosConst.POS_CAT_MASTER.TRADE_ID.CAT_HAPPY_SEARCH)
                {
                    // 조회
                    sAddInfo += CmUtil.RPadH("", 10);                           // 요청 사용자 ID                               
                    sAddInfo += CmUtil.RPadH(m_cPosStatus.Base.StoreNo, 10);    // 점포코드
                    sAddInfo += CmUtil.RPadH(m_cPosStatus.Base.PosNo, 2);       // 포스번호
                    sAddInfo += CmUtil.RPadH("", 178);                          // VReserved
                }
                else
                {
                    // 적립,적립취소
                    sAddInfo += CmUtil.RPadH("", 10);                           // 요청 사용자 ID
                    sAddInfo += CmUtil.RPadH(m_cPosStatus.Base.SaleDate, 8);    // POS 영업일자 - POS 매출일자 8자리
                    sAddInfo += "1001";                                         // 거래사유코드 - 1001:대금결제, 1002:포인트고객적립, 1003:운영사이벤트, 1004:제휴사 이벤트
                    sAddInfo += CmUtil.RPadH(m_cPosStatus.Base.SaleDate, 10);   // SAP 코드 - POS 매출일자 10자리
                    sAddInfo += CmUtil.RPadH(m_cPosStatus.Base.PosNo, 2);       // POS 번호
                    sAddInfo += "10";                                           // 요청구분 - 10:일반적립, 20:캐시포인트적립
                    sAddInfo += "10";                                           // 적립방식구분코드 - 10:즉시적립, 20:영수증추후적립                    
                    sAddInfo += string.Format("{0:D10}", CmUtil.LongParse(aParam[3]));  // 총적립대상금액
                    sAddInfo += "0000000";                                      // 캐시포인트 - 고객이 현금을 캐쉬로 적립 요청한 경우 적립할 캐시포인트
                    sAddInfo += CmUtil.RPadH("", 20);                           // 결제카드번호 - 신용 결제한 카드번호
                    sAddInfo += CmUtil.RPadH("", 125);                          // VReserved
                }

                aParam[11] = sAddInfo;

                string sRecvdData = "";
                string sAppLogDiv = "";
                string sInputType = "";

                if (sAppType == PosConst.POS_CAT_MASTER.TRADE_ID.CAT_HAPPY_SAVE || sAppType == PosConst.POS_CAT_MASTER.TRADE_ID.CAT_HAPPY_SEARCH)
                {
                    sAppLogDiv = PosConst.CANCEL_DIV.NORMAL;
                }
                else
                {
                    sAppLogDiv = PosConst.CANCEL_DIV.CANCEL;
                }

                string[] aIrtDTLRsp = new string[Column.POS_RES_SPCN_CAT.LEN.Length];

                //전문 송/수신
                if (CatTerminalExecuteIrtCom(sAppType, sAppLogDiv, aParam, m_cEtcItem.ETC_WAY_CD, m_cEtcItem.ETC_DTL_CD_01, ref aIrtDTLRsp, ref sRecvdData, ref sInputType) == false)
                {
                    //WinManager.ErrorMessage(sRecvdData);
                    return sRet;
                }

                if (sAppLogDiv == PosConst.CANCEL_DIV.NORMAL)
                {
                    m_cEtcItem.ETC_DTL_CD_05 = PosConst.PAY_DC_TYPE.NORMAL;                                                             // 할인결제구분 (1:결제, 2:할인)

                    m_cEtcItem.ETC_AMT = CmUtil.DoubleParse(CmUtil.MidH(aIrtDTLRsp[Column.POS_RES_SPCN_CAT.SEQ.AddItem], 0, 9));         // 적립포인트
                    m_cEtcItem.AMT_ENTRY_01 = CmUtil.DoubleParse(CmUtil.MidH(aIrtDTLRsp[Column.POS_RES_SPCN_CAT.SEQ.AddItem], 0, 9));    // 적립포인트     
                    m_cEtcItem.AMT_ENTRY_03 = CmUtil.DoubleParse(CmUtil.MidH(aIrtDTLRsp[Column.POS_RES_SPCN_CAT.SEQ.AddItem], 18, 9));   // 총포인트(누적포인트)

                    if (sAppType == PosConst.POS_CAT_MASTER.TRADE_ID.CAT_HAPPY_SEARCH)
                        m_cEtcItem.AMT_ENTRY_04 = CmUtil.DoubleParse(CmUtil.MidH(aIrtDTLRsp[Column.POS_RES_SPCN_CAT.SEQ.AddItem], 9, 9));   // 가용포인트

                    m_cEtcItem.AMT_ENTRY_05 = CmUtil.DoubleParse(CmUtil.MidH(aIrtDTLRsp[Column.POS_RES_SPCN_CAT.SEQ.AddItem], 18, 9));      // 누적포인트
                    m_cEtcItem.AMT_ENTRY_08 = CmUtil.DoubleParse(aParam[3]);            // 적립대상금액1(기본적립)

                    m_cEtcItem.OCCUR_ENTRY_01 = aIrtDTLRsp[Column.POS_RES_SPCN_CAT.SEQ.CardBinData].Trim().Length == 6 ? aIrtDTLRsp[Column.POS_RES_SPCN_CAT.SEQ.CardBinData].Trim() + "*********" : aIrtDTLRsp[Column.POS_RES_SPCN_CAT.SEQ.CardBinData].Trim();  // 카드번호
                    m_cEtcItem.OCCUR_ENTRY_02 = aIrtDTLRsp[Column.POS_RES_SPCN_CAT.SEQ.AppNo].Trim();                    // 승인번호
                    m_cEtcItem.OCCUR_ENTRY_03 = CmUtil.MidH(aIrtDTLRsp[Column.POS_RES_SPCN_CAT.SEQ.AppDatatime], 0, 6);  // 승인일자
                    m_cEtcItem.OCCUR_ENTRY_04 = CmUtil.MidH(aIrtDTLRsp[Column.POS_RES_SPCN_CAT.SEQ.AppDatatime], 6, 4);  // 승인시간
                    m_cEtcItem.OCCUR_ENTRY_05 = sInputType;                     // 입력 구분
                    m_cEtcItem.OCCUR_ENTRY_06 = "";                             // 원승인번호
                    m_cEtcItem.OCCUR_ENTRY_07 = "";                             // 원승인일자
                    m_cEtcItem.OCCUR_ENTRY_08 = ItemConst.PAY_APP_DIV.CAT_TERMINAL;   //승인구분
                    m_cEtcItem.OCCUR_ENTRY_09 = "0";                            // 거래후 적립 구분(0:일반, 1:사후)
                    m_cEtcItem.OCCUR_ENTRY_12 = "N";                            // 앱고객 여부(N:일반, Y:앱고객)
                    m_cEtcItem.OCCUR_ENTRY_16 = GetPayDtlCdToVanCode(m_cEtcItem.ETC_WAY_CD, m_cEtcItem.ETC_DTL_CD_01);      // VAN 구분
                    m_cEtcItem.OCCUR_ENTRY_18 = aIrtDTLRsp[Column.POS_RES_SPCN_CAT.SEQ.FranchiseNo];                     // 가맹점번호
                    m_cEtcItem.OCCUR_ENTRY_20 = GetPayDtlCdToPayDtlName(m_cEtcItem.ETC_WAY_CD, m_cEtcItem.ETC_DTL_CD_01);   // 결제수단명
                    m_cEtcItem.OCCUR_ENTRY_21 = GetPayDtlCdToCashBillYn(m_cEtcItem.ETC_WAY_CD, m_cEtcItem.ETC_DTL_CD_01);   // 현금영수증 발행여부

                    m_cEtcItem.CANCEL_DIV = ItemConst.PAY_CANCEL_DIV.NORMAL;
                    m_cEtcItem.BILLSPR_NO = m_cTrnStatus.Sale.BillSplitNo;      // 빌분리 번호

                    m_cEtcItem.HP_RESERVED = "";        // 예약필드
                    m_cEtcItem.HP_CAMPAIGN_INFO = "";   // 캠페인정보
                    m_cEtcItem.HP_ADD_INFO_SCH = "";    // 추가응답정보
                    m_cEtcItem.HP_ADD_INFO_SAVE = "";   // 추가응답정보

                }
                else
                {
                    m_cEtcItem.AMT_ENTRY_03 = CmUtil.DoubleParse(CmUtil.MidH(aIrtDTLRsp[Column.POS_RES_SPCN_CAT.SEQ.AddItem], 18, 9));   // 총포인트(누적포인트)
                    m_cEtcItem.AMT_ENTRY_05 = CmUtil.DoubleParse(CmUtil.MidH(aIrtDTLRsp[Column.POS_RES_SPCN_CAT.SEQ.AddItem], 18, 9));   // 누적포인트

                    m_cEtcItem.OCCUR_ENTRY_01 = aIrtDTLRsp[Column.POS_RES_SPCN_CAT.SEQ.CardBinData].Trim().Length == 6 ? aIrtDTLRsp[Column.POS_RES_SPCN_CAT.SEQ.CardBinData].Trim() + "*********" : aIrtDTLRsp[Column.POS_RES_SPCN_CAT.SEQ.CardBinData].Trim();  // 카드번호

                    m_cEtcItem.OCCUR_ENTRY_06 = m_cEtcItem.OCCUR_ENTRY_02;                // 원승인번호
                    m_cEtcItem.OCCUR_ENTRY_07 = m_cEtcItem.OCCUR_ENTRY_03;              // 원승인일자

                    m_cEtcItem.OCCUR_ENTRY_02 = aIrtDTLRsp[Column.POS_RES_SPCN_CAT.SEQ.AppNo].Trim();                       // 승인번호
                    m_cEtcItem.OCCUR_ENTRY_03 = CmUtil.MidH(aIrtDTLRsp[Column.POS_RES_SPCN_CAT.SEQ.AppDatatime], 0, 6);     // 승인일자
                    m_cEtcItem.OCCUR_ENTRY_04 = CmUtil.MidH(aIrtDTLRsp[Column.POS_RES_SPCN_CAT.SEQ.AppDatatime], 6, 4);     // 승인시간
                    m_cEtcItem.OCCUR_ENTRY_05 = sInputType;             // 입력 구분
                    
                    m_cEtcItem.HP_ADD_INFO_SAVE = "";    // 추가응답정보

                }
                sRet = UserCom.RST_OK;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                   System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            return sRet;
        }
        #endregion
    }
}
